=== debian/changelog ===
gvmd (26.5.0-1) unstable; urgency=medium

  * New upstream version 26.5.0
  * Refresh patches
  * Remove obsolete manpage greenbone-feed-sync
  * Update debian/watch to Version 5

 -- Sophie Brun <sophie@kali.org>  Fri, 31 Oct 2025 11:33:10 +0100
