=== debian/tests/control ===
Tests: test
Restrictions: allow-stderr
Depends: @, @builddeps@, libcgreen1-dev
