## gvmd 26.12.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,13 +19,13 @@
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.5.0 LANGUAGES C)
+project(gvm VERSION 26.12.1 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
 endif(POLICY CMP0005)
 
-set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
 
 include(FindPkgConfig)
 
@@ -250,10 +250,10 @@
 endif(NOT GVM_DEFAULT_DROP_USER)
 
 # Feature toggles
-if(NOT OPENVASD)
-  set(OPENVASD 0)
-endif(NOT OPENVASD)
-add_definitions(-DOPENVASD=${OPENVASD})
+if(NOT ENABLE_OPENVASD)
+  set(ENABLE_OPENVASD 0)
+endif(NOT ENABLE_OPENVASD)
+add_definitions(-DENABLE_OPENVASD=${ENABLE_OPENVASD})
 
 if(NOT ENABLE_AGENTS)
   set(ENABLE_AGENTS 0)
@@ -272,11 +272,6 @@
   set(ENDIF_NOT_ENABLE_AGENTS "")
 endif()
 
-if(NOT FEED_VT_METADATA)
-  set(FEED_VT_METADATA 0)
-endif(NOT FEED_VT_METADATA)
-add_definitions(-DFEED_VT_METADATA=${FEED_VT_METADATA})
-
 if(NOT ENABLE_CONTAINER_SCANNING)
   set(ENABLE_CONTAINER_SCANNING 0)
 endif(NOT ENABLE_CONTAINER_SCANNING)
@@ -290,13 +285,27 @@
   set(ENDIF_ENABLE_CONTAINER_SCANNNING "-->")
 endif()
 
-# HTTP scanner capability (used by OPENVASD / AGENTS / CONTAINER_SCANNING)
-if(OPENVASD OR ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
+# HTTP scanner capability (used by ENABLE_OPENVASD / AGENTS / CONTAINER_SCANNING)
+if(ENABLE_OPENVASD OR ENABLE_AGENTS OR ENABLE_CONTAINER_SCANNING)
   set(ENABLE_HTTP_SCANNER 1)
 else()
   set(ENABLE_HTTP_SCANNER 0)
 endif()
 add_definitions(-DENABLE_HTTP_SCANNER=${ENABLE_HTTP_SCANNER})
+
+# Credential stores
+if(NOT ENABLE_CREDENTIAL_STORES)
+  set(ENABLE_CREDENTIAL_STORES 0)
+endif(NOT ENABLE_CREDENTIAL_STORES)
+add_definitions(-DENABLE_CREDENTIAL_STORES=${ENABLE_CREDENTIAL_STORES})
+
+if(ENABLE_CREDENTIAL_STORES EQUAL 1)
+  set(IF_ENABLE_CREDENTIAL_STORES "")
+  set(ENDIF_ENABLE_CREDENTIAL_STORES "")
+elseif(ENABLE_CONTAINER_SCANNING EQUAL 0)
+  set(IF_ENABLE_CREDENTIAL_STORES "<!--")
+  set(ENDIF_ENABLE_CREDENTIAL_STORES "-->")
+endif()
 
 message("-- Install prefix: ${CMAKE_INSTALL_PREFIX}")
 message("-- Log file: ${GVMD_LOG_FILE}")
@@ -391,21 +400,3 @@
 
 install(
   FILES ${CMAKE_BINARY_DIR}/src/gvmd_log.conf
-  DESTINATION ${GVM_SYSCONF_DIR}
-)
-
-install(
-  FILES ${CMAKE_SOURCE_DIR}/src/pwpolicy.conf
-  DESTINATION ${GVM_SYSCONF_DIR}
-)
-
-# Schema formats.
-
-install(
-  FILES src/schema_formats/rnc.xsl
-  DESTINATION ${GVMD_DATA_DIR}/global_schema_formats/
-  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
-)
-
-install(
-  FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl
