=== src/CMakeLists.txt ===
--- 
+++ 
@@ -27,38 +27,44 @@
 ## might occur.
 
 pkg_check_modules(CJSON REQUIRED libcjson>=1.7.14)
-pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.29)
-pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.29)
-pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.29)
-pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.29)
+pkg_check_modules(LIBGVM_BASE REQUIRED libgvm_base>=22.30)
+pkg_check_modules(LIBGVM_UTIL REQUIRED libgvm_util>=22.31)
+pkg_check_modules(LIBGVM_OSP REQUIRED libgvm_osp>=22.30)
+pkg_check_modules(LIBGVM_GMP REQUIRED libgvm_gmp>=22.30)
 
 if(ENABLE_HTTP_SCANNER)
-  pkg_check_modules(LIBGVM_HTTP REQUIRED libgvm_http>=22.29)
-  pkg_check_modules(LIBGVM_HTTP_SCANNER REQUIRED libgvm_http_scanner>=22.29)
+  pkg_check_modules(LIBGVM_HTTP REQUIRED libgvm_http>=22.30)
+  pkg_check_modules(LIBGVM_HTTP_SCANNER REQUIRED libgvm_http_scanner>=22.30)
 endif(ENABLE_HTTP_SCANNER)
-if(OPENVASD)
-  pkg_check_modules(LIBGVM_OPENVASD REQUIRED libgvm_openvasd>=22.29)
-else(OPENVASD)
-  message(STATUS "OPENVASD flag is not enabled")
-endif(OPENVASD)
+if(ENABLE_OPENVASD)
+  pkg_check_modules(LIBGVM_OPENVASD REQUIRED libgvm_openvasd>=22.30)
+else(ENABLE_OPENVASD)
+  message(STATUS "ENABLE_OPENVASD flag is not enabled")
+endif(ENABLE_OPENVASD)
 if(ENABLE_AGENTS)
   pkg_check_modules(
     LIBGVM_AGENT_CONTROLLER
     REQUIRED
-    libgvm_agent_controller>=22.29
+    libgvm_agent_controller>=22.30
   )
 else(ENABLE_AGENTS)
   message(STATUS "ENABLE_AGENTS flag is not enabled")
 endif(ENABLE_AGENTS)
+if(ENABLE_CREDENTIAL_STORES)
+  pkg_check_modules(LIBGVM_CYBERARK REQUIRED libgvm_cyberark>=22.30)
+else(ENABLE_CREDENTIAL_STORES)
+  message(STATUS "ENABLE_CREDENTIAL_STORES flag is not enabled")
+endif(ENABLE_CREDENTIAL_STORES)
 if(ENABLE_CONTAINER_SCANNING)
   pkg_check_modules(
     LIBGVM_CONTAINER_IMAGE_SCANNER
     REQUIRED
-    libgvm_container_image_scanner>=22.29
+    libgvm_container_image_scanner>=22.30
   )
 else(ENABLE_CONTAINER_SCANNING)
   message(STATUS "ENABLE_CONTAINER_SCANNING flag is not enabled")
 endif(ENABLE_CONTAINER_SCANNING)
+
 pkg_check_modules(GNUTLS REQUIRED gnutls>=3.2.15)
 pkg_check_modules(GLIB REQUIRED glib-2.0>=2.42)
 pkg_check_modules(LIBBSD REQUIRED libbsd)
@@ -166,11 +172,14 @@
   manage.c
   manage_acl.c
   manage_alerts.c
+  manage_credential_store_cyberark.c
+  manage_credential_stores.c
   manage_configs.c
   manage_events.c
   manage_filter_utils.c
   manage_commands.c
   manage_get.c
+  manage_groups.c
   manage_http_scanner.c
   manage_license.c
   manage_openvas.c
@@ -180,6 +189,7 @@
   manage_resources.c
   manage_report_configs.c
   manage_report_formats.c
+  manage_runtime_flags.c
   manage_authentication.c
   manage_settings.c
   manage_tls_certificates.c
@@ -194,8 +204,7 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_MANAGE_SRC
+    APPEND ALL_MANAGE_SRC
     manage_agent_common.c
     manage_agent_groups.c
     manage_agents.c
@@ -210,8 +219,10 @@
   manage_sql_copy.c
   manage_sql_alerts.c
   manage_sql_assets.c
+  manage_sql_credential_stores.c
   manage_sql_events.c
   manage_sql_filters.c
+  manage_sql_groups.c
   manage_sql_nvts.c
   manage_sql_secinfo.c
   manage_sql_port_lists.c
@@ -229,8 +240,7 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_MANAGE_SQL_SRC
+    APPEND ALL_MANAGE_SQL_SRC
     manage_sql_agent_groups.c
     manage_sql_agents.c
     manage_sql_agent_installers.c
@@ -256,13 +266,16 @@
 
 if(ENABLE_AGENTS)
   list(
-    APPEND
-    ALL_GMP_SRC
+    APPEND ALL_GMP_SRC
     gmp_agent_control_scan_agent_config.c
     gmp_agent_groups.c
     gmp_agents.c
     gmp_agent_installers.c
   )
+endif()
+
+if(ENABLE_CREDENTIAL_STORES)
+  list(APPEND ALL_GMP_SRC gmp_credential_stores.c)
 endif()
 
 set(ALL_SQL_SRC sql.c sql_pg.c)
@@ -289,6 +302,23 @@
 add_library(all-sql-obj OBJECT ${ALL_SQL_SRC})
 
 add_library(all-misc-obj OBJECT ${ALL_MISC_SRC})
+
+## Precommit-like checks
+
+if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
+  add_custom_target(
+    check-whitespace
+    ALL
+    # once for output
+    COMMAND
+      grep -Hn "[ ]$$" *.c *.h | sed
+      "'s/^\\(.\\+:.\\+:\\)/\\1 error: trailing space: /'"
+    # again for exit code
+    COMMAND ! grep --quiet "[ ]$$" *.c *.h
+    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+    COMMENT "Checking whitespace..."
+  )
+endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")
 
 ## Program
 
@@ -345,6 +375,7 @@
   ${LIBGVM_GMP_LDFLAGS}
   ${LIBGVM_HTTP_LDFLAGS}
   ${LIBGVM_HTTP_SCANNER_LDFLAGS}
+  ${LIBGVM_CYBERARK_LDFLAGS}
   ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
   ${LIBICAL_LDFLAGS}
   ${LINKER_HARDENING_FLAGS}
@@ -365,59 +396,26 @@
 
 set_target_properties(gvmd PROPERTIES LINKER_LANGUAGE C)
 
-macro(add_unit_test _baseName _objects _extraSource)
-  string(REPLACE "-" "_" _testSource "${_baseName}")
-  # manage_filter_utils.c
-  set(_source "${_testSource}.c")
-  # manage_filter_utils_tests.c
-  set(_testSource "${_testSource}_tests.c")
-  # manage-filter-utils-test
-  set(_testName "${_baseName}-test")
-
-  list(APPEND TEST_DEPENDENCIES ${_testName})
-  set(TEST_TARGET_EXTRA_SRC ${_extraSource})
-  list(REMOVE_ITEM TEST_TARGET_EXTRA_SRC ${_source})
-
-  add_executable(
-    ${_testName}
-    EXCLUDE_FROM_ALL
-    ${_testSource}
-    ${_objects}
-    ${TEST_TARGET_EXTRA_SRC}
-  )
-  add_test(${_testName} ${_testName})
-  target_link_libraries(
-    ${_testName}
-    cgreen
-    m
-    ${GNUTLS_LDFLAGS}
-    ${GPGME_LDFLAGS}
-    ${CMAKE_THREAD_LIBS_INIT}
-    ${LINKER_HARDENING_FLAGS}
-    ${LINKER_DEBUG_FLAGS}
-    ${PostgreSQL_LIBRARIES}
-    ${LIBBSD_LDFLAGS}
-    ${CJSON_LDFLAGS}
-    ${GLIB_LDFLAGS}
-    ${GTHREAD_LDFLAGS}
-    ${LIBGVM_AGENT_CONTROLLER_LDFLAGS}
-    ${LIBGVM_BASE_LDFLAGS}
-    ${LIBGVM_UTIL_LDFLAGS}
-    ${LIBGVM_OSP_LDFLAGS}
-    ${LIBGVM_OPENVASD_LDFLAGS}
-    ${LIBGVM_GMP_LDFLAGS}
-    ${LIBGVM_HTTP_LDFLAGS}
-    ${LIBGVM_HTTP_SCANNER_LDFLAGS}
-    ${LIBGVM_CONTAINER_IMAGE_SCANNER_LDFLAGS}
-    ${LIBICAL_LDFLAGS}
-    ${LINKER_HARDENING_FLAGS}
-    ${OPT_THEIA_TGT}
-  )
-  set_target_properties(${_testName} PROPERTIES LINKER_LANGUAGE C)
-  if(NOT CMAKE_BUILD_TYPE MATCHES "Release")
-    target_compile_options(${_testName} PUBLIC ${C_FLAGS_DEBUG_GVMD})
-  endif(NOT CMAKE_BUILD_TYPE MATCHES "Release")
-endmacro()
+include(${CMAKE_SOURCE_DIR}/cmake/add_unit_test.cmake)
+
+if(ENABLE_CREDENTIAL_STORES)
+  set(
+    ALL_OBJECTS
+    $<TARGET_OBJECTS:all-manage-obj>
+    $<TARGET_OBJECTS:all-manage-sql-obj>
+    $<TARGET_OBJECTS:all-misc-obj>
+  )
+  set(EXTRA_SRC ${ALL_GMP_SRC} ${ALL_SQL_SRC})
+  list(REMOVE_ITEM EXTRA_SRC gmp_credential_stores.c)
+  add_unit_test(gmp-credential-stores "${ALL_OBJECTS}" "${EXTRA_SRC}")
+  # Add linker wrap flag for acl_user_may to avoid multiple definition error
+  set_target_properties(
+    gmp-credential-stores-test
+    PROPERTIES
+      LINK_FLAGS
+        "-Wl,-wrap,acl_user_may,-wrap,find_resource_with_permission,-wrap,sql_begin_immediate,-wrap,sql_rollback,-wrap,find_resource_with_permission,-wrap,sql_string"
+  )
+endif()
 
 set(
   ALL_OBJECTS
@@ -447,11 +445,7 @@
   )
   set(EXTRA_SRC ${ALL_MANAGE_SRC})
   list(REMOVE_ITEM EXTRA_SRC manage_sql_agent_installers.c)
-  add_unit_test(
-    manage-agent-installers
-    "${ALL_OBJECTS}"
-    "${EXTRA_SRC}"
-  )
+  add_unit_test(manage-agent-installers "${ALL_OBJECTS}" "${EXTRA_SRC}")
 endif()
 
 set(
@@ -465,9 +459,3 @@
 
 if(ENABLE_CONTAINER_SCANNING)
   set(
-    ALL_OBJECTS
-    $<TARGET_OBJECTS:all-gmp-obj>
-    $<TARGET_OBJECTS:all-manage-sql-obj>
-    $<TARGET_OBJECTS:all-misc-obj>
-    $<TARGET_OBJECTS:all-sql-obj>
-  )
