=== debian/changelog ===
gvmd (26.12.1-2) unstable; urgency=medium

  * Use default unix_socket /run/ospd/ospd.sock

 -- Sophie Brun <sophie@kali.org>  Fri, 19 Dec 2025 11:19:05 +0100

gvmd (26.12.1-1) unstable; urgency=medium

  * New upstream version 26.12.1
  * Refresh patches
  * Update minimal required version of libgvm
  * Refresh copyright
  * Add python3-lxml as dep of gvmd-common

 -- Sophie Brun <sophie@kali.org>  Thu, 04 Dec 2025 11:03:31 +0100
