=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                debhelper-compat (= 13),
                doxygen,
                gnutls-bin,
-               libgvm-dev (>= 22.23.0),
+               libgvm-dev (>= 22.31.0),
                libical-dev,
 	       libbsd-dev,
 	       libcjson-dev,
@@ -52,7 +52,7 @@
 	 greenbone-feed-sync (>= 24.1.1),
          gvmd-common (= ${source:Version}),
 	 notus-scanner (>= 22.4.0),
-         ospd-openvas (>= 22.4.0),
+         ospd-openvas (>= 22.9.1-2),
          xml-twig-tools,
          ${misc:Depends},
          ${postgresql:Depends},
