## gvmd 26.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,12 @@
 # Copyright (C) 2009-2022 Greenbone AG
 #
 # SPDX-License-Identifier: AGPL-3.0-or-later
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU Affero General Public License as
-# published by the Free Software Foundation, either version 3 of the
-# License, or (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU Affero General Public License for more details.
-#
-# You should have received a copy of the GNU Affero General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 cmake_minimum_required(VERSION 3.5)
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.12.1 LANGUAGES C)
+project(gvm VERSION 26.13.0 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -109,7 +96,7 @@
 
 ## Variables
 
-set(GVMD_DATABASE_VERSION 262)
+set(GVMD_DATABASE_VERSION 264)
 
 set(GVMD_SCAP_DATABASE_VERSION 22)
 
@@ -400,3 +387,29 @@
 
 install(
   FILES ${CMAKE_BINARY_DIR}/src/gvmd_log.conf
+  DESTINATION ${GVM_SYSCONF_DIR}
+)
+
+install(
+  FILES ${CMAKE_SOURCE_DIR}/src/pwpolicy.conf
+  DESTINATION ${GVM_SYSCONF_DIR}
+)
+
+# Schema formats.
+
+install(
+  FILES src/schema_formats/rnc.xsl
+  DESTINATION ${GVMD_DATA_DIR}/global_schema_formats/
+  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+)
+
+install(
+  FILES src/schema_formats/rnc.xsl src/schema_formats/HTML/HTML.xsl
+  DESTINATION
+    ${GVMD_DATA_DIR}/global_schema_formats/02052818-dab6-11df-9be4-002264764cea/
+  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ
+)
+
+install(
+  FILES src/schema_formats/HTML/generate
+  DESTINATION
