=== debian/changelog ===
gvmd (26.13.0-1) unstable; urgency=medium

  * New upstream version 26.13.0
  * Update minimal required version
  * Update debian/copyright

 -- Sophie Brun <sophie@kali.org>  Thu, 08 Jan 2026 11:06:08 +0100
