## gvmd 26.14.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 message("-- Configuring Greenbone Vulnerability Manager...")
 
-project(gvm VERSION 26.13.0 LANGUAGES C)
+project(gvm VERSION 26.14.0 LANGUAGES C)
 
 if(POLICY CMP0005)
   cmake_policy(SET CMP0005 NEW)
@@ -96,7 +96,7 @@
 
 ## Variables
 
-set(GVMD_DATABASE_VERSION 264)
+set(GVMD_DATABASE_VERSION 265)
 
 set(GVMD_SCAP_DATABASE_VERSION 22)
