=== src/CMakeLists.txt ===
--- 
+++ 
@@ -188,6 +188,7 @@
   manage_scan_queue.c
   manage_oci_image_targets.c
   manage_container_image_scanner.c
+  manage_users.c
 )
 
 if(ENABLE_AGENTS)
@@ -220,6 +221,7 @@
   manage_sql_roles.c
   manage_sql_tickets.c
   manage_sql_tls_certificates.c
+  manage_sql_users.c
   manage_sql_nvts_osp.c
   manage_sql_nvts_openvasd.c
   manage_sql_nvts_common.c
@@ -470,4 +472,3 @@
   ALL_OBJECTS
   $<TARGET_OBJECTS:all-gmp-obj>
   $<TARGET_OBJECTS:all-manage-sql-obj>
-  $<TARGET_OBJECTS:all-misc-obj>
