=== debian/changelog ===
gvmd (26.14.0-1) unstable; urgency=medium

  * New upstream version 26.14.0
  * Refresh patches

 -- Sophie Brun <sophie@kali.org>  Thu, 22 Jan 2026 17:04:17 +0100
